# Publications using mHM
- Hanel, M., Rakovec, O., Markonis, Y., Maca, P., Samaniego, L., Kysely, J., Kumar, R. (2018): Revisiting the recent European droughts from a long-term perspective, Scientific Reports, https://doi.org/10.1038/s41598-018-27464-4
- Demirel, M.C., Mai, J., Mendiguren, G., Koch, J., Samaniego, L., Stisen, S. (2018): Combining satellite data and appropriate objective functions for improved spatial pattern performance of a distributed hydrologic model, Hydrol. Earth Syst. Sci. 22 (2), 1299 - 1315, https://www.hydrol-earth-syst-sci.net/22/1299/2018/
- Koch, J., Demirel, M. C., and Stisen, S. (2018): The SPAtial EFficiency metric (SPAEF): multiple-component evaluation of spatial patterns for optimization of hydrological models, Geosci. Model Dev., 11, 1873-1886, https://doi.org/10.5194/gmd-11-1873-2018/
- Höllering, S., Wienhöfer, J., Ihringer, J., Samaniego, L., Zehe, E. (2018): Regional analysis of parameter sensitivity for simulation of streamflow and hydrological fingerprints, Hydrol. Earth Syst. Sci. 22 (1), 203 - 220, https://www.hydrol-earth-syst-sci.net/22/203/2018/
- Jing, M., Heße, F., Kumar, R., Wang, W., Fischer, T., Walther, M., Zink, M., Zech, A., Samaniego, L., Kolditz, O., Attinger, S. (2018): Improved regional-scale groundwater representation by the coupling of the mesoscale Hydrologic Model (mHM v5.7) to the groundwater model OpenGeoSys (OGS), Geosci. Model Dev. 11 (5), 1989 - 2007, https://www.geosci-model-dev.net/11/1989/2018/
- Peichl, M., Thober, S., Meyer, V., Samaniego, L. (2018): The effect of soil moisture anomalies on maize yield in Germany, Nat. Hazards Earth Syst. Sci. 18 (3), 889 - 906, https://www.nat-hazards-earth-syst-sci.net/18/889/2018/
- Samaniego, L., Thober, S., Kumar, R., Wanders, N., Rakovec, O., Pan, M., Zink, M., Sheffield, J., Wood, E.F., Marx, A. (2018): Anthropogenic warming exacerbates European soil moisture droughts, Nat. Clim. Chang. 8 (5), 421 - 426, https://www.nature.com/articles/s41558-018-0138-5
- Marx, A., Kumar, R., Thober, S., Rakovec, O., Wanders, N., Zink, M., Wood, E.F., Pan, M., Sheffield, J., Samaniego, L. (2018): Climate change alters low flows in Europe under global warming of 1.5, 2, and 3 degC, Hydrol. Earth Syst. Sci. 22 (2), 1017 - 1032, https://www.hydrol-earth-syst-sci.net/22/1017/2018/
- Schrön, M., Rosolem, R., Köhli, M., Piussi, L., Schröter, I., Iwema, J., Kögler, S., Oswald, S.E., Wollschläger, U., Samaniego, L., Dietrich, P., Zacharias, S. (2018):
Cosmic‐ray neutron rover surveys of field soil moisture and the influence of roads, Water Resour. Res., https://doi.org/10.1029/2017WR021719
- Thober, S., Kumar, R., Wanders, N., Marx, A., Pan, M., Rakovec, O., Samaniego, L., Sheffield, J., Wood, E.F., Zink, M. (2018): Multi-model ensemble projections of European river floods and high flows at 1.5, 2, and 3 degrees global warming, Environ. Res. Lett. 13 (1), art. 014003, http://iopscience.iop.org/article/10.1088/1748-9326/aa9e35
- Zink, M., Mai, J., Cuntz, M., Samaniego, L. (2018): Conditioning a hydrologic model using patterns of remotely sensed land surface temperature, Water Resour. Res. 54 (4), 2976 - 2998,  https://doi.org/10.1002/2017WR021346
- Samaniego, L., Kumar, R., Thober, S., Rakovec, O., Zink, M., Wanders, N., Eisner, S., Müller Schmied, H., Sutanudjaja, E.H., Warrach-Sagi, K., Attinger, S., (2017): Toward seamless hydrologic predictions across spatial scales, Hydrol. Earth Syst. Sci. 21 (9), 4323 - 4346, https://www.hydrol-earth-syst-sci.net/21/4323/2017/
- Samaniego, L., Kumar, R., Breuer, L., Chamorro, A., Flörke, M., Pechlivanidis, I.G., Schäfer, D., Shah, H., Vetter, T., Wortmann, M., Zeng, X., (2017): Propagation of forcing and model uncertainties on to hydrological drought characteristics in a multi-model century-long experiment in large river basins, Clim. Change 141 (3), 435 - 449, https://link.springer.com/article/10.1007/s10584-016-1778-y
- Vigiak, O., Lutz, S., Mentzafou, A., Chiogna, G., Ye, T., Majone, B., Beck, H., de Roo, A., Malagó, A., Bouraoui, F., Kumar, R., Samaniego, L., Merz, R., Gamvroudis, C., Skoulikidis, N., Nikolaidis, N.P., Bellin, A., Acuňa, V., Mori, N., Ludwig, R., Pistocchi, A., (2018): Uncertainty of modelled flow regime for flow-ecological assessment in Southern Europe, Sci. Total Environ. 615 , 1028 - 1047, https://www.sciencedirect.com/science/article/pii/S0048969717326475
- Eisner, S., Flörke, M., Chamorro, A., Daggupati, P., Donnelly, C., Huang, J., Hundecha, Y., Koch, H., Kalugin, A., Krylenko, I., Mishra, V., Piniewski, M., Samaniego, L., Seidou, O., Wallner, M., Krysanova, V., (2017): An ensemble analysis of climate change impacts on streamflow seasonality across 11 large river basins, Clim. Change 141 (3), 401 - 417, https://link.springer.com/article/10.1007/s10584-016-1844-5
- Pechlivanidis, I.G., Arheimer, B., Donnelly, C., Hundecha, Y., Huang, S., Aich, V., Samaniego, L., Eisner, S. and Shi, P., (2017): Analysis of hydrological extremes at different hydro-climatic regimes under present and future conditions. Climatic Change, 141(3), pp.467-481, https://link.springer.com/article/10.1007/s10584-016-1723-0
- Hattermann, F.F., Krysanova, V., Gosling, S.N., Dankers, R., Daggupati, P., Donnelly, C., Flörke, M., Huang, S., Motovilov, Y., Buda, S., Yang, T., Müller, C., Leng, G., Tang, Q., Portmann, F.T., Hagemann, S., Gerten, D., Wada, Y., Masaki, Y., Alemayehu, T., Satoh, Y., Samaniego, L., (2017): Cross‐scale intercomparison of climate change impacts simulated by regional and global hydrological models in eleven large river basins, Clim. Change 141 (3), 561 - 576, https://link.springer.com/article/10.1007/s10584-016-1829-4
- Hattermann, F.F., Vetter, T., Breuer, L., Su, B., Daggupati, P., Donnelly, C., Fekete, B., Flörke, F., Gosling, S.N., Hoffmann, P., Liersch, S., Masaki, Y., Motovilov, Y., Müller, C., Samaniego, L., Stacke, T., Wada, Y., Yang, T., Krysnaova, V., (2017): Sources of uncertainty in hydrological climate impact assessment: a cross-scale study, Environ. Res. Lett., http://iopscience.iop.org/article/10.1088/1748-9326/aa9938/meta
- Mishra, V., Kumar, R., Shah, H.L., Samaniego, L., Eisner, S., Yang, T., (2017): Multimodel assessment of sensitivity and uncertainty of evapotranspiration and a proxy for available water resources under climate change, Clim. Change 141 (3), 451 - 465, https://link.springer.com/article/10.1007/s10584-016-1886-8
- Zink, M., Kumar, R., Cuntz, M., & Samaniego, L. (2017). A high-resolution dataset of water fluxes and states for Germany accounting for parametric uncertainty. Hydrology and Earth System Sciences, 21(3), 1769–1790. doi:10.5194/hess-21-1769-2017, http://www.hydrol-earth-syst-sci.net/21/1769/2017/hess-21-1769-2017.html
- Heße, F., Zink, M., Kumar, R., Samaniego, L., & Attinger, S. (2017). Spatially distributed characterization of soil-moisture dynamics using travel-time distributions. Hydrology and Earth System Sciences, 21(1), 549–570. doi:10.5194/hess-21-549-2017, http://www.hydrol-earth-syst-sci.net/21/549/2017/
- Baroni, G., Zink, M., Kumar, R., Samaniego, L., & Attinger, S. (2017). Effects of uncertainty in soil properties on simulated hydrological states and fluxes at different spatio-temporal scales. Hydrology and Earth System Sciences, 21(5), 2301–2320. doi:10.5194/hess-21-2301-2017, http://www.hydrol-earth-syst-sci.net/21/2301/2017/hess-21-2301-2017.html
- Wollschlaeger, U., Attinger, S., Borchardt, D., Brauns, M., Cuntz, M., Dietrich, P., … Zacharias, S. (2017). The Bode hydrological observatory: a platform for integrated, interdisciplinary hydro-ecological research within the TERENO Harz/Central German Lowland Observatory. Environmental Earth Sciences, 76(1), 29. doi:10.1007/s12665-016-6327-5, https://link.springer.com/article/10.1007/s12665-016-6327-5
- Mueller, C., Zink, M., Samaniego, L., Krieg, R., Merz, R., Rode, M., & Knoeller, K. (2016). Discharge Driven Nitrogen Dynamics in a Mesoscale River Basin As Constrained by Stable Isotope Patterns. Environmental Science & Technology, 50(17), 9187–9196. doi:10.1021/acs.est.6b01057, http://pubs.acs.org/doi/abs/10.1021/acs.est.6b01057
- Zink, M., Samaniego, L., Kumar, R., Thober, S., Mai, J., Schaefer, D., & Marx, A. (2016). The German drought monitor. Environmental Research Letters, 11(7), 74002. doi:10.1088/1748-9326/11/7/074002, http://iopscience.iop.org/article/10.1088/1748-9326/11/7/074002/meta
- Marx, A., Samaniego, L., Kumar, R., Thober, S., Mai, J., & Zink, M. (2016). Der Duerremonitor - Aktuelle Information zur Bodenfeuchte in Deutschland. In Wasserressourcen - Wissen in Flussgebieten vernetzen (pp. 131–142). Forum fuer Hydrologie und Wasserbewirtschaftung, http://www.ufz.de/index.php?en=20939&ufzPublicationIdentifier=17277
- Rakovec, O., Kumar, R., Mai, J., Cuntz, M., Thober, S., Zink, M., Attinger, S., Schaefer, D., Schroen, M., Samaniego, L. (2016). Multiscale and Multivariate Evaluation of Water Fluxes and States over European River Basins. Journal of Hydrometeorology, 17(1), 287–307. doi:10.1175/JHM-D-15-0054.1, http://journals.ametsoc.org/doi/abs/10.1175/JHM-D-15-0054.1
- Rakovec, O., Kumar, R., Attinger, S. and Samaniego, L. (2016). Improving the realism of hydrologic model functioning through multivariate parameter estimation. Water Resources Research, 52. doi:10.1002/2016WR019430, http://onlinelibrary.wiley.com/doi/10.1002/2016WR019430/full
- Nijzink, R. C., Samaniego, L., Mai, J., Kumar, R., Thober, S., Zink, M., Schaefer, D., Savenije, H. H. G., and Hrachowitz, M.: The importance of topography-controlled sub-grid process heterogeneity and semi-quantitative prior constraints in distributed hydrological models, Hydrol. Earth Syst. Sci., 20, 1151-1176, doi:10.5194/hess-20-1151-2016, 2016., http://www.hydrol-earth-syst-sci.net/20/1151/2016/
- Thober, S., Kumar, R., Sheffield, J., Mai, J., Schaefer, D., & Samaniego, L. (2015). Seasonal Soil Moisture Drought Prediction over Europe Using the North American Multi-Model Ensemble (NMME). Journal of Hydrometeorology, 16(6), 2329–2344. doi:10.1175/JHM-D-15-0053.1, http://journals.ametsoc.org/doi/abs/10.1175/JHM-D-15-0053.1
- Cuntz, M., Mai, J., Zink, M., Thober, S., Kumar, R., Schaefer, D., … Samaniego, L. (2015). Computationally inexpensive identification of noninformative model parameters by sequential screening. Water Resources Research, 51(8), 6417–6441. doi:10.1002/2015WR016907, http://onlinelibrary.wiley.com/doi/10.1002/2015WR016907/full
- Livneh, B., Kumar, R., & Samaniego, L. (2015). Influence of soil textural properties on hydrologic fluxes in the Mississippi river basin. Hydrological Processes, 29(21), 4638-4655, http://onlinelibrary.wiley.com/doi/10.1002/hyp.10601/full
- Schoeniger, A., Woehling, T., Samaniego, L., & Nowak, W. (2014). Model selection on solid ground: Rigorous comparison of nine ways to evaluate Bayesian model evidence. Water resources research, 50(12), 9484-9513, http://onlinelibrary.wiley.com/doi/10.1002/2014WR016062/full
- Woehling, T., Samaniego, L., & Kumar, R. (2013). Evaluating multiple performance criteria to calibrate the distributed hydrological model of the upper Neckar catchment. Environmental Earth Sciences, 69(2), 453–468. doi:10.1007/s12665-013-2306-2, https://link.springer.com/article/10.1007/s12665-013-2306-2
- Samaniego, L., Kumar, R., & Zink, M. (2013). Implications of Parameter Uncertainty on Soil Moisture Drought Analysis in Germany. Journal of Hydrometeorology, 14(1), 47–68. doi:10.1175/JHM-D-12-075.1, http://journals.ametsoc.org/doi/abs/10.1175/JHM-D-12-075.1
- Kumar, R., Livneh, B., & Samaniego, L. (2013). Toward computationally efficient large-scale hydrologic predictions with a multiscale regionalization scheme. Water Resources Research, 49(9), 5700–5714. doi:10.1002/wrcr.20431, http://onlinelibrary.wiley.com/doi/10.1002/wrcr.20431/full
- Kumar, R., Samaniego, L., & Attinger, S. (2013). Implications of distributed hydrologic model parameterization on water fluxes at multiple scales and locations. Water Resources Research, 49(1), 360–379. doi:10.1029/2012WR012195, http://onlinelibrary.wiley.com/doi/10.1029/2012WR012195/abstract
- Zacharias, S., Bogena, H., Samaniego, L., Mauder, M., Fuß, R., Puetz, T., ... & Bens, O. (2011). A network of terrestrial environmental observatories in Germany. Vadose Zone Journal, 10(3), 955-973, https://dl.sciencesocieties.org/publications/vzj/abstracts/10/3/955
- Kalbacher, T., Delfs, J. O., Shao, H., Wang, W., Walther, M., Samaniego, L., ... & Sun, F. (2012). The IWAS-ToolBox: software coupling for an integrated water resources management. Environmental Earth Sciences, 65(5), 1367-1380, https://link.springer.com/article/10.1007/s12665-011-1270-y
- Samaniego, L., Kumar, R., & Jackisch, C. (2011). Predictions in a data-sparse region using a regionalized grid-based hydrologic model driven by remotely sensed data. Hydrology Research, 42(5), 338–355. doi:10.2166/nh.2011.156, http://hr.iwaponline.com/content/42/5/338.article-info
- Kumar, R., Samaniego, L., & Attinger, S. (2010). The effects of spatial discretization and model parameterization on the prediction of extreme runoff characteristics. Journal of Hydrology, 392(1-2), 54–69. doi:10.1016/j.jhydrol.2010.07.047, http://www.sciencedirect.com/science/article/pii/S0022169410004865
- Samaniego, L., Kumar, R., & Attinger, S. (2010). Multiscale parameter regionalization of a grid-based hydrologic model at the mesoscale. Water Resources Research, 46(5), W05523. doi:10.1029/2008WR007327, http://onlinelibrary.wiley.com/doi/10.1029/2008WR007327/full
